"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentInfosGenerator = void 0;
const fs = __importStar(require("fs"));
const _config_1 = require("./_config");
const path_1 = __importDefault(require("path"));
class ComponentInfosGenerator {
    constructor(componentDirName, componentMkdirPath, componentFiles) {
        this.componentDirName = componentDirName;
        this.componentMkdirPath = componentMkdirPath;
        this.componentFiles = componentFiles;
    }
    static build(templateInfos, argReplaceValue, optSubDomainName) {
        var _a;
        const checkReplaceValue = this.checkReplaceValue(argReplaceValue);
        if (checkReplaceValue instanceof Error)
            return checkReplaceValue;
        const compomentDirNameResult = this.createComponentDirName(templateInfos.templateDirInfo.dirName, argReplaceValue);
        if (compomentDirNameResult instanceof Error)
            return compomentDirNameResult;
        const absolutePathcomponantWorkDirResult = this.getComponentWorkDirPath((_a = templateInfos.templateConfigFile) === null || _a === void 0 ? void 0 : _a.componentWorkDirectory, optSubDomainName);
        if (absolutePathcomponantWorkDirResult instanceof Error)
            return absolutePathcomponantWorkDirResult;
        const componentMkdirPath = `${absolutePathcomponantWorkDirResult}/${compomentDirNameResult}`;
        const componentFilesInfoResult = this.createComponentFilesInfo(templateInfos.templateFilesInfo, argReplaceValue);
        if (componentFilesInfoResult instanceof Error)
            return componentFilesInfoResult;
        return new ComponentInfosGenerator(compomentDirNameResult, componentMkdirPath, componentFilesInfoResult);
    }
    static checkReplaceValue(replaceValue) {
        if (replaceValue === "")
            return new Error("Vous devez fournir le nom du composant a créer (ex: 'Guitare') ");
    }
    static getComponentWorkDirPath(compWrkDirRelativePath, subDomainName) {
        const domainRelativePath = _config_1.JsonGlobalConfigFile.domainWorkDirectory;
        const domainAbsolutePath = path_1.default.resolve(domainRelativePath);
        if (!fs.existsSync(domainAbsolutePath))
            return new Error(`Le domaine "${domainRelativePath}" n'existe pas dans votre projet :\n "${path_1.default.resolve()}"`);
        let componentWrkDirAbsolutePath, subDomainAbsolutePath;
        if (subDomainName) {
            subDomainAbsolutePath = `${domainRelativePath}/${subDomainName}`;
            if (!fs.existsSync(subDomainAbsolutePath))
                return new Error(`Le sous-domaine "${subDomainName}" n'existe pas dans : \n ${path_1.default.relative(path_1.default.resolve(), domainAbsolutePath)}`);
        }
        if (subDomainName && compWrkDirRelativePath) {
            componentWrkDirAbsolutePath = `${subDomainAbsolutePath}/${compWrkDirRelativePath}`;
            if (!fs.existsSync(componentWrkDirAbsolutePath))
                return new Error(`Le répertoire de travail "${compWrkDirRelativePath}" n'existe pas dans : \n  ${path_1.default.relative(path_1.default.resolve(), subDomainAbsolutePath)}`);
        }
        else if (!subDomainName && compWrkDirRelativePath) {
            componentWrkDirAbsolutePath = `${domainAbsolutePath}/${compWrkDirRelativePath}`;
            if (!fs.existsSync(componentWrkDirAbsolutePath))
                return new Error(`Le répertoire de travail "${compWrkDirRelativePath}" n'existe pas dans : \n  ${path_1.default.relative(path_1.default.resolve(), domainAbsolutePath)}`);
        }
        else
            componentWrkDirAbsolutePath = domainAbsolutePath;
        return componentWrkDirAbsolutePath;
    }
    static createComponentDirName(templateDirName, replaceValue) {
        const templateDirNameParted = _config_1.regexDirectory.exec(templateDirName);
        if (!templateDirNameParted || !templateDirNameParted[2])
            return new Error(`Problème sur le template ${templateDirName} : ${_config_1.ERR_TEMPLATE_DIR_NAME_PART2}`);
        return templateDirNameParted[2].replace(_config_1.keywordReplacement, replaceValue);
    }
    static createComponentFilesInfo(templateFilesInfos, replaceValue) {
        return templateFilesInfos.map(templateFileInfo => ({
            fileName: templateFileInfo.fileName.replace(_config_1.keywordReplacement, replaceValue),
            data: ""
        }));
    }
}
exports.ComponentInfosGenerator = ComponentInfosGenerator;
//# sourceMappingURL=ComponentInfosGenerator.js.map