import { ITemplateConfigFile } from "./_definitions/ITemplateConfigFile";
export declare type ITemplateDirInfos = {
    dirName: string;
    dirPath: string;
};
export declare type ITemplateFileInfo = {
    fileName: string;
    filePath: string;
};
export interface ITemplateReader {
    templateName: string;
    templateDirInfo: ITemplateDirInfos;
    templateFilesInfo: ITemplateFileInfo[];
    templateConfigFile: ITemplateConfigFile | null;
}
export declare class TemplateReader implements ITemplateReader {
    templateName: string;
    templateDirInfo: ITemplateDirInfos;
    templateFilesInfo: ITemplateFileInfo[];
    templateConfigFile: ITemplateConfigFile | null;
    private constructor();
    static build(wtedTemplateName: string): Promise<ITemplateReader | Error>;
    private static findWantedTemplate;
    private static getAllTemplateDirInfo;
    static getAllTemplateFilesInfo(templateDirPath: any): Promise<ITemplateFileInfo[] | Error>;
    private static checkAllTemplateDirInfo;
    private static getTemplateName;
    private static getTemplateConfigFile;
}
