#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const create_1 = require("./commands/create");
const CommandEnum_1 = require("./_definitions/CommandEnum");
const _config_1 = require("./_config");
const fs_1 = __importDefault(require("fs"));
const preChecking = () => {
    if (!fs_1.default.existsSync(_config_1.absolutePathConfigDir))
        return new Error(`Le répertoire de configuration "${_config_1.nameConfigDir}" est manquant ! \n 
    Lancez la cmd "$${_config_1.cliCommandName} init" pour initialiser les fichiers de configuration obligatoires.
    `);
    if (!_config_1.JsonGlobalConfigFile)
        return new Error(`Le fichier de configuration "${_config_1.nameConfigDir}/${_config_1.nameGlobalConfigFile}" est manquant
    Lancez la cmd "$${_config_1.cliCommandName} init" pour initialiser les fichiers de configuration obligatoires.
    `);
    if (!_config_1.JsonGlobalConfigFile.domainWorkDirectory)
        return new Error(`Le chemin du domain de travail principal est manquant ! \n 
    Vous devez founir le chemin du répertoire de travail (Exemple : "/src/core")`);
};
const run = () => __awaiter(void 0, void 0, void 0, function* () {
    const preCheckResult = preChecking();
    if (preCheckResult instanceof Error)
        console.log(preCheckResult.message);
    const program = new commander_1.Command();
    program.version('0.0.1');
    /*program
      .command('init')
      .description(`If config file does not exist : Create configs files and 1 example modele \n
      Else if configs files alrady exist : check their validity, and save configuration`)
      .action(initialize)*/
    program
        .command(CommandEnum_1.CommandEnum.create)
        .argument('<templateName>', "Template to use")
        .argument('<replacementName>', "Replacement word")
        .option('-s, --subdomain <subdomain>', 'Allwos to choose a subdomain in which the component will be created')
        .description(`Create component`)
        .action(create_1.create);
    yield program.parseAsync(process.argv);
});
run().then();
//# sourceMappingURL=app.js.map