"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const TemplateReader_1 = require("../TemplateReader");
const ComponentInfosGenerator_1 = require("../ComponentInfosGenerator");
const createComponent_1 = require("../FilesHandlers/createComponent");
const create = (templateName, replaceValue, opts) => __awaiter(void 0, void 0, void 0, function* () {
    const templateInfos = yield TemplateReader_1.TemplateReader.build(templateName);
    if (templateInfos instanceof Error)
        return console.log(templateInfos.message);
    const componentInformations = ComponentInfosGenerator_1.ComponentInfosGenerator.build(templateInfos, replaceValue, opts === null || opts === void 0 ? void 0 : opts.subdomain);
    if (componentInformations instanceof Error)
        return console.log(componentInformations.message);
    const componentCreation = (0, createComponent_1.createComponent)(componentInformations.componentMkdirPath, componentInformations.componentDirName, componentInformations.componentFiles);
    if (componentCreation instanceof Error)
        return console.log(componentCreation.message);
    console.log("Le composant à été créer avec succès");
});
exports.create = create;
//# sourceMappingURL=create.js.map